diff --git a/drivers/net/wireless/celeno/cl8k/cecli.h b/drivers/net/wireless/celeno/cl8k/cecli.h
new file mode 100644
index 000000000000..3260ca56e563
--- /dev/null
+++ b/drivers/net/wireless/celeno/cl8k/cecli.h
@@ -0,0 +1,112 @@
+/* SPDX-License-Identifier: MIT */
+/* Copyright(c) 2019-2021, Celeno Communications Ltd. */
+
+#ifndef CL_CECLI_H
+#define CL_CECLI_H
+
+#include <net/cfg80211.h>
+#include <net/mac80211.h>
+#include <linux/version.h>
+
+/**
+ * DOC: Cecli - command line interface wrapper
+ *
+ * Allows to control the driver behavior and inspect statistics, utilizes
+ * vendor specific commands and events from the nl80211 layer.
+ */
+
+int cl_cecli_acs(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_agc_params(struct wiphy *wiphy, struct wireless_dev *wdev,
+                       const void *data, int data_len);
+int cl_cecli_bf(struct wiphy *wiphy, struct wireless_dev *wdev,
+               const void *data, int data_len);
+int cl_cecli_bss_color(struct wiphy *wiphy, struct wireless_dev *wdev,
+                      const void *data, int data_len);
+int cl_cecli_calib(struct wiphy *wiphy, struct wireless_dev *wdev,
+                  const void *data, int data_len);
+int cl_cecli_cca(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_chip(struct wiphy *wiphy, struct wireless_dev *wdev,
+                 const void *data, int data_len);
+int cl_cecli_config(struct wiphy *wiphy, struct wireless_dev *wdev,
+                   const void *data, int data_len);
+int cl_cecli_debug(struct wiphy *wiphy, struct wireless_dev *wdev,
+                  const void *data, int data_len);
+int cl_cecli_dfs(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_edca(struct wiphy *wiphy, struct wireless_dev *wdev,
+                 const void *data, int data_len);
+int cl_cecli_fw(struct wiphy *wiphy, struct wireless_dev *wdev,
+               const void *data, int data_len);
+int cl_cecli_motion(struct wiphy *wiphy, struct wireless_dev *wdev,
+                   const void *data, int data_len);
+int cl_cecli_noise(struct wiphy *wiphy, struct wireless_dev *wdev,
+                  const void *data, int data_len);
+int cl_cecli_omi(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_power(struct wiphy *wiphy, struct wireless_dev *wdev,
+                  const void *data, int data_len);
+int cl_cecli_qos(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_radio(struct wiphy *wiphy, struct wireless_dev *wdev,
+                  const void *data, int data_len);
+int cl_cecli_reg(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_sounding(struct wiphy *wiphy, struct wireless_dev *wdev,
+                     const void *data, int data_len);
+int cl_cecli_stats(struct wiphy *wiphy, struct wireless_dev *wdev,
+                  const void *data, int data_len);
+int cl_cecli_tcv(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_temp(struct wiphy *wiphy, struct wireless_dev *wdev,
+                 const void *data, int data_len);
+int cl_cecli_traffic(struct wiphy *wiphy, struct wireless_dev *wdev,
+                    const void *data, int data_len);
+int cl_cecli_twt(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_txq(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_version(struct wiphy *wiphy, struct wireless_dev *wdev,
+                    const void *data, int data_len);
+int cl_cecli_vns(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_wrs(struct wiphy *wiphy, struct wireless_dev *wdev,
+                const void *data, int data_len);
+int cl_cecli_help(struct wiphy *wiphy, struct wireless_dev *wdev,
+                 const void *data, int data_len);
+
+enum cl_cecli_cmd {
+       CL_CECLI_AGC_PARAMS,
+       CL_CECLI_BF,
+       CL_CECLI_CALIB,
+       CL_CECLI_CCA,
+       CL_CECLI_CHIP,
+       CL_CECLI_CONFIG,
+       CL_CECLI_DEBUG,
+       CL_CECLI_DFS,
+       CL_CECLI_EDCA,
+       CL_CECLI_FW,
+       CL_CECLI_MORE_DATA,
+       CL_CECLI_MOTION,
+       CL_CECLI_NOISE,
+       CL_CECLI_OMI,
+       CL_CECLI_POWER,
+       CL_CECLI_QOS,
+       CL_CECLI_RADIO,
+       CL_CECLI_REG,
+       CL_CECLI_SOUNDING,
+       CL_CECLI_STATS,
+       CL_CECLI_TCV,
+       CL_CECLI_TEMP,
+       CL_CECLI_TRAFFIC,
+       CL_CECLI_TWT,
+       CL_CECLI_TXQ,
+       CL_CECLI_VERSION,
+       CL_CECLI_VNS,
+       CL_CECLI_WRS,
+
+       CL_CECLI_MAX
+};
+
+#endif /* CL_CECLI_H */