diff --git a/drivers/net/wireless/celeno/cl8k/fw/fw_msg.c b/drivers/net/wireless/celeno/cl8k/fw/fw_msg.c
new file mode 100644
index 000000000000..ea59bf57fa97
--- /dev/null
+++ b/drivers/net/wireless/celeno/cl8k/fw/fw_msg.c
@@ -0,0 +1,135 @@
+// SPDX-License-Identifier: MIT
+/* Copyright(c) 2019-2021, Celeno Communications Ltd. */
+
+#include "fw/fw_msg.h"
+
+/* Should be used for REQ and CFM only */
+const char *const msg2str[MSG_TOTAL_REQ_CFM] = {
+       /* MM messages */
+       [MM_RESET_REQ] = "MM_RESET_REQ",
+       [MM_RESET_CFM] = "MM_RESET_CFM",
+       [MM_START_REQ] = "MM_START_REQ",
+       [MM_START_CFM] = "MM_START_CFM",
+       [MM_VERSION_REQ] = "MM_VERSION_REQ",
+       [MM_VERSION_CFM] = "MM_VERSION_CFM",
+       [MM_ADD_IF_REQ] = "MM_ADD_IF_REQ",
+       [MM_ADD_IF_CFM] = "MM_ADD_IF_CFM",
+       [MM_REMOVE_IF_REQ] = "MM_REMOVE_IF_REQ",
+       [MM_REMOVE_IF_CFM] = "MM_REMOVE_IF_CFM",
+       [MM_STA_ADD_REQ] = "MM_STA_ADD_REQ",
+       [MM_STA_ADD_CFM] = "MM_STA_ADD_CFM",
+       [MM_STA_DEL_REQ] = "MM_STA_DEL_REQ",
+       [MM_STA_DEL_CFM] = "MM_STA_DEL_CFM",
+       [MM_SET_FILTER_REQ] = "MM_SET_FILTER_REQ",
+       [MM_SET_FILTER_CFM] = "MM_SET_FILTER_CFM",
+       [MM_SET_CHANNEL_REQ] = "MM_SET_CHANNEL_REQ",
+       [MM_SET_CHANNEL_CFM] = "MM_SET_CHANNEL_CFM",
+       [MM_SET_DTIM_REQ] = "MM_SET_DTIM_REQ",
+       [MM_SET_DTIM_CFM] = "MM_SET_DTIM_CFM",
+       [MM_SET_BEACON_INT_REQ] = "MM_SET_BEACON_INT_REQ",
+       [MM_SET_BEACON_INT_CFM] = "MM_SET_BEACON_INT_CFM",
+       [MM_SET_BASIC_RATES_REQ] = "MM_SET_BASIC_RATES_REQ",
+       [MM_SET_BASIC_RATES_CFM] = "MM_SET_BASIC_RATES_CFM",
+       [MM_SET_BSSID_REQ] = "MM_SET_BSSID_REQ",
+       [MM_SET_BSSID_CFM] = "MM_SET_BSSID_CFM",
+       [MM_SET_EDCA_REQ] = "MM_SET_EDCA_REQ",
+       [MM_SET_EDCA_CFM] = "MM_SET_EDCA_CFM",
+       [MM_SET_ASSOCIATED_REQ] = "MM_SET_ASSOCIATED_REQ",
+       [MM_SET_ASSOCIATED_CFM] = "MM_SET_ASSOCIATED_CFM",
+       [MM_SET_SLOTTIME_REQ] = "MM_SET_SLOTTIME_REQ",
+       [MM_SET_SLOTTIME_CFM] = "MM_SET_SLOTTIME_CFM",
+       [MM_SET_IDLE_REQ] = "MM_SET_IDLE_REQ",
+       [MM_SET_IDLE_CFM] = "MM_SET_IDLE_CFM",
+       [MM_KEY_ADD_REQ] = "MM_KEY_ADD_REQ",
+       [MM_KEY_ADD_CFM] = "MM_KEY_ADD_CFM",
+       [MM_KEY_DEL_REQ] = "MM_KEY_DEL_REQ",
+       [MM_KEY_DEL_CFM] = "MM_KEY_DEL_CFM",
+       [MM_BA_ADD_TX_REQ] = "MM_BA_ADD_TX_REQ",
+       [MM_BA_ADD_TX_CFM] = "MM_BA_ADD_TX_CFM",
+       [MM_BA_ADD_RX_REQ] = "MM_BA_ADD_RX_REQ",
+       [MM_BA_ADD_RX_CFM] = "MM_BA_ADD_RX_CFM",
+       [MM_BA_DEL_REQ] = "MM_BA_DEL_REQ",
+       [MM_BA_DEL_CFM] = "MM_BA_DEL_CFM",
+       [MM_PHY_RESET_REQ] = "MM_PHY_RESET_REQ",
+       [MM_PHY_RESET_CFM] = "MM_PHY_RESET_CFM",
+       [MM_AVAILABLE_BA_TXQ_REQ] = "MM_AVAILABLE_BA_TXQ_REQ",
+       [MM_AVAILABLE_BA_TXQ_CFM] = "MM_AVAILABLE_BA_TXQ_CFM",
+       [MM_UPDATE_RATE_DL_REQ] = "MM_UPDATE_RATE_DL_REQ",
+       [MM_UPDATE_RATE_DL_CFM] = "MM_UPDATE_RATE_DL_CFM",
+       [MM_SET_VNS_REQ] = "MM_SET_VNS_REQ",
+       [MM_SET_VNS_CFM] = "MM_SET_VNS_CFM",
+       [MM_SET_TX_BF_REQ] = "MM_SET_TX_BF_REQ",
+       [MM_SET_TX_BF_CFM] = "MM_SET_TX_BF_CFM",
+       [MM_SOUNDING_REQ] = "MM_SOUNDING_REQ",
+       [MM_SOUNDING_CFM] = "MM_SOUNDING_CFM",
+       [MM_SOUNDING_PAIRING_REQ] = "MM_SOUNDING_PAIRING_REQ",
+       [MM_SOUNDING_PAIRING_CFM] = "MM_SOUNDING_PAIRING_CFM",
+       [MM_SOUNDING_INTERVAL_REQ] = "MM_SOUNDING_INTERVAL_REQ",
+       [MM_SOUNDING_INTERVAL_CFM] = "MM_SOUNDING_INTERVAL_CFM",
+       [MM_SOUNDING_STA_SWITCH_REQ] = "MM_SOUNDING_STA_SWITCH_REQ",
+       [MM_SOUNDING_STA_SWITCH_CFM] = "MM_SOUNDING_STA_SWITCH_CFM",
+       [MM_CONFIG_CCA_REQ] = "MM_CONFIG_CCA_REQ",
+       [MM_CONFIG_CCA_CFM] = "MM_CONFIG_CCA_CFM",
+       [MM_SET_DFS_REQ] = "MM_SET_DFS_REQ",
+       [MM_SET_DFS_CFM] = "MM_SET_DFS_CFM",
+       [MM_SET_ANT_BITMAP_REQ] = "MM_SET_ANT_BITMAP_REQ",
+       [MM_SET_ANT_BITMAP_CFM] = "MM_SET_ANT_BITMAP_CFM",
+       [MM_NDP_TX_CONTROL_REQ] = "MM_NDP_TX_CONTROL_REQ",
+       [MM_NDP_TX_CONTROL_CFM] = "MM_NDP_TX_CONTROL_CFM",
+       [MM_REG_WRITE_REQ] = "MM_REG_WRITE_REQ",
+       [MM_REG_WRITE_CFM] = "MM_REG_WRITE_CFM",
+       [MM_PROT_MODE_REQ] = "MM_PROT_MODE_REQ",
+       [MM_PROT_MODE_CFM] = "MM_PROT_MODE_CFM",
+       [MM_GOTO_POWER_REDUCTION_REQ] = "MM_GOTO_POWER_REDUCTION_REQ",
+       [MM_GOTO_POWER_REDUCTION_CFM] = "MM_GOTO_POWER_REDUCTION_CFM",
+       [MM_BACKUP_BCN_EN_REQ] = "MM_BACKUP_BCN_EN_REQ",
+       [MM_BACKUP_BCN_EN_CFM] = "MM_BACKUP_BCN_EN_CFM",
+       [MM_START_PERIODIC_TX_TIME_REQ] = "MM_START_PERIODIC_TX_TIME_REQ",
+       [MM_START_PERIODIC_TX_TIME_CFM] = "MM_START_PERIODIC_TX_TIME_CFM",
+       [MM_ANAMON_READ_REQ] = "MM_ANAMON_READ_REQ",
+       [MM_ANAMON_READ_CFM] = "MM_ANAMON_READ_CFM",
+       [MM_REFRESH_PWR_REQ] = "MM_REFRESH_PWR_REQ",
+       [MM_REFRESH_PWR_CFM] = "MM_REFRESH_PWR_CFM",
+       [MM_SET_ANT_PWR_OFFSET_REQ] = "MM_SET_ANT_PWR_OFFSET_REQ",
+       [MM_SET_ANT_PWR_OFFSET_CFM] = "MM_SET_ANT_PWR_OFFSET_CFM",
+       [MM_SET_RATE_FALLBACK_REQ] = "MM_SET_RATE_FALLBACK_REQ",
+       [MM_SET_RATE_FALLBACK_CFM] = "MM_SET_RATE_FALLBACK_CFM",
+       [MM_TWT_SETUP_REQ] = "MM_TWT_SETUP_REQ",
+       [MM_TWT_SETUP_CFM] = "MM_TWT_SETUP_CFM",
+       [MM_TWT_TEARDOWN_REQ] = "MM_TWT_TEARDOWN_REQ",
+       [MM_TWT_TEARDOWN_CFM] = "MM_TWT_TEARDOWN_CFM",
+       [MM_RSRC_MGMT_REQ] = "MM_RSRC_MGMT_REQ",
+       [MM_RSRC_MGMT_CFM] = "MM_RSRC_MGMT_CFM",
+       [MM_SET_FREQ_OFFSET_REQ] = "MM_SET_FREQ_OFFSET_REQ",
+       [MM_SET_FREQ_OFFSET_CFM] = "MM_SET_FREQ_OFFSET_CFM",
+
+       /* DBG messages */
+       [DBG_STR_SHIFT(DBG_SET_MOD_FILTER_REQ)] = "DBG_SET_MOD_FILTER_REQ",
+       [DBG_STR_SHIFT(DBG_SET_MOD_FILTER_CFM)] = "DBG_SET_MOD_FILTER_CFM",
+       [DBG_STR_SHIFT(DBG_CE_SET_MOD_FILTER_REQ)] = "DBG_CE_SET_MOD_FILTER_REQ",
+       [DBG_STR_SHIFT(DBG_CE_SET_MOD_FILTER_CFM)] = "DBG_CE_SET_MOD_FILTER_CFM",
+       [DBG_STR_SHIFT(DBG_SET_SEV_FILTER_REQ)] = "DBG_SET_SEV_FILTER_REQ",
+       [DBG_STR_SHIFT(DBG_SET_SEV_FILTER_CFM)] = "DBG_SET_SEV_FILTER_CFM",
+       [DBG_STR_SHIFT(DBG_BEAMFORMING_TX_REQ)] = "DBG_BEAMFORMING_TX_REQ",
+       [DBG_STR_SHIFT(DBG_BEAMFORMING_TX_CFM)] = "DBG_BEAMFORMING_TX_CFM",
+       [DBG_STR_SHIFT(DBG_GET_E2W_STATS_REQ)] = "DBG_GET_E2W_STATS_REQ",
+       [DBG_STR_SHIFT(DBG_GET_E2W_STATS_CFM)] = "DBG_GET_E2W_STATS_CFM",
+       [DBG_STR_SHIFT(DBG_SET_LA_MPIF_MASK_REQ)] = "DBG_SET_LA_MPIF_MASK_REQ",
+       [DBG_STR_SHIFT(DBG_SET_LA_MPIF_MASK_CFM)] = "DBG_SET_LA_MPIF_MASK_CFM",
+       [DBG_STR_SHIFT(DBG_SET_LA_TRIG_POINT_REQ)] = "DBG_SET_LA_TRIG_POINT_REQ",
+       [DBG_STR_SHIFT(DBG_SET_LA_TRIG_POINT_CFM)] = "DBG_SET_LA_TRIG_POINT_CFM",
+       [DBG_STR_SHIFT(DBG_SET_LA_MPIF_DEBUG_MODE_REQ)] = "DBG_SET_LA_MPIF_DEBUG_MODE_REQ",
+       [DBG_STR_SHIFT(DBG_SET_LA_MPIF_DEBUG_MODE_CFM)] = "DBG_SET_LA_MPIF_DEBUG_MODE_CFM",
+       [DBG_STR_SHIFT(DBG_SET_LA_TRIG_RULE_REQ)] = "DBG_SET_LA_TRIG_RULE_REQ",
+       [DBG_STR_SHIFT(DBG_SET_LA_TRIG_RULE_CFM)] = "DBG_SET_LA_TRIG_RULE_CFM",
+       [DBG_STR_SHIFT(DBG_TX_TRACE_DEBUG_FLAG_REQ)] = "DBG_TX_TRACE_DEBUG_FLAG_REQ",
+       [DBG_STR_SHIFT(DBG_TX_TRACE_DEBUG_FLAG_CFM)] = "DBG_TX_TRACE_DEBUG_FLAG_CFM",
+       [DBG_STR_SHIFT(DBG_PRINT_STATS_REQ)] = "DBG_PRINT_STATS_REQ",
+       [DBG_STR_SHIFT(DBG_PRINT_STATS_CFM)] = "DBG_PRINT_STATS_CFM",
+       [DBG_STR_SHIFT(DBG_TRIGGER_REQ)] = "DBG_TRIGGER_REQ",
+       [DBG_STR_SHIFT(DBG_TRIGGER_CFM)] = "DBG_TRIGGER_CFM",
+       [DBG_STR_SHIFT(DBG_TEST_MODE_REQ)] = "DBG_TEST_MODE_REQ",
+       [DBG_STR_SHIFT(DBG_TEST_MODE_CFM)] = "DBG_TEST_MODE_CFM",
+       [DBG_STR_SHIFT(DBG_SOUNDING_CMD_REQ)] = "DBG_SOUNDING_CMD_REQ",
+       [DBG_STR_SHIFT(DBG_SOUNDING_CMD_CFM)] = "DBG_SOUNDING_CMD_CFM",
+};